unit uAddPet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls, uDM, uRace,
  uColor, uTitle, uParent;

type
  TfAddPet = class(TForm)
    leName: TLabeledEdit;
    dBirth: TDateTimePicker;
    cbSex: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    bOK: TBitBtn;
    bCancel: TBitBtn;
    leRace: TLabeledEdit;
    bRace: TButton;
    leColor: TLabeledEdit;
    bColor: TButton;
    leTitle: TLabeledEdit;
    bTitle: TButton;
    lePapa: TLabeledEdit;
    leMama: TLabeledEdit;
    bPapa: TButton;
    bMama: TButton;
    procedure bOKClick(Sender: TObject);
    procedure bRaceClick(Sender: TObject);
    procedure bColorClick(Sender: TObject);
    procedure bTitleClick(Sender: TObject);
    procedure bPapaClick(Sender: TObject);
    procedure bMamaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    nSex: byte;
    nRace: word;
    nColor: word;
    nTitle: byte;
    nPapa: word;
    nMama: word;
    procedure Init_Data;
    procedure Load_Data;
  end;

var
  fAddPet: TfAddPet;

implementation

{$R *.dfm}

procedure TfAddPet.Init_Data;
begin
 nSex := 0;
 nRace := 0;
 nColor := 0;
 nTitle := 0;
 nPapa := 0;
 nMama := 0;
 leName.Text := '';
 leRace.Text := '';
 leColor.Text := '';
 leTitle.Text := '';
 lePapa.Text := '';
 leMama.Text := '';
end;

procedure TfAddPet.Load_Data;
begin
 nSex := dm.qPetsMain.FieldValues['sex_cod'];
 cbSex.ItemIndex := nSex;
 nRace := dm.qPetsMain.FieldValues['race_cod'];
 nTitle := dm.qPetsMain.FieldValues['title'];
 nColor := dm.qPetsMain.FieldValues['color_cod'];
 nPapa := dm.qPetsMain.FieldValues['father_cod'];
 nMama := dm.qPetsMain.FieldValues['mother_cod'];
 leName.Text := dm.qPetsMain.FieldValues['name'];
 dBirth.DateTime := dm.qPetsMain.FieldValues['birth'];

 if nRace <> 0 then
    leRace.Text := dm.qPetsMain.FieldValues['race_name']
 else
    leRace.Text := '';

 if nColor <> 0 then
    leColor.Text := dm.qPetsMain.FieldValues['color_name']
 else
    leColor.Text := '';

 if nTitle <> 0 then
    leTitle.Text := dm.qPetsMain.FieldValues['title_name']
 else
    leTitle.Text := '';
    
 lePapa.Text := dm.qPetsMain.FieldValues['father_nam'];
 leMama.Text := dm.qPetsMain.FieldValues['mother_nam'];
end;

procedure TfAddPet.bOKClick(Sender: TObject);
begin
 If is_empty(leName.Text) then
    begin
      ShowMessage(',   !');
      leName.SetFocus;
      ModalResult := mrNone;
      Exit;
    end;

 If cbSex.ItemIndex < 0 then
    begin
      ShowMessage(',   !');
      cbSex.SetFocus;
      ModalResult := mrNone;
      Exit;
    end;

 nSex := cbSex.ItemIndex;

 If Is_Empty(lePapa.Text)
    then lePapa.Text := '<???>';
    
 If Is_Empty(leMama.Text)
    then leMama.Text := '<???>';
end;

procedure TfAddPet.bRaceClick(Sender: TObject);
begin
  fRace.ShowModal;

  if fRace.ModalResult = mrOK then
     begin
       leRace.Text := fRace.cName;
       nRace := fRace.nCod;
     end;
end;

procedure TfAddPet.bColorClick(Sender: TObject);
begin
  fColor.ShowModal;

  if fColor.ModalResult = mrOK then
     begin
       leColor.Text := fColor.cName;
       nColor := fColor.nCod;
     end;
end;

procedure TfAddPet.bTitleClick(Sender: TObject);
begin
  fTitle.ShowModal;

  if fTitle.ModalResult = mrOK then
     begin
       leTitle.Text := fTitle.cName;
       nTitle := fTitle.nCod;
     end;
end;

procedure TfAddPet.bPapaClick(Sender: TObject);
begin
  fParent.ShowModal;

  if fParent.ModalResult = mrOK then
     begin
       lePapa.Text := fParent.cParent;
       nPapa := fParent.nCod;
     end;
end;

procedure TfAddPet.bMamaClick(Sender: TObject);
begin
  fParent.ShowModal;

  if fParent.ModalResult = mrOK then
     begin
       leMama.Text := fParent.cParent;
       nMama := fParent.nCod;
     end;
end;

end.
