unit uDM;

interface

uses
  SysUtils, Classes, DB, DBTables, Dialogs, Controls;

type
  TDM = class(TDataModule)
    qPetsMain: TQuery;
    dsPets: TDataSource;
    qPetsAdd: TQuery;
    qPetsGetCode: TQuery;
    qRace: TQuery;
    dsRace: TDataSource;
    dsColor: TDataSource;
    qColor: TQuery;
    qTitle: TQuery;
    dsTitle: TDataSource;
    qTmp: TQuery;
    dsTmp: TDataSource;
    qParent: TQuery;
    dsParent: TDataSource;
    qFindParent: TQuery;
    dsFindParent: TDataSource;
  private
    { Private declarations }
  public
    { Public declarations }
    function GetNewCode(cSQL,cField: string): word;
    procedure SqlInsert(cSQL,cValue1,cValue2: string);
    procedure SqlDelete(cBase, cField: string; var qTable: TQuery);
    procedure SqlUpdate(cSQL, cField, cValue: string; var qTable: TQuery);
  end;

function YesToKill: boolean;
Function Is_Empty(s: string): boolean;

var
  DM: TDM;

  MainSQL: TStringList;

  RootDir: string;

  SortingSQL: Array[1..2] of string;
  SortIndex: Byte;

implementation

{$R *.dfm}

function TDM.GetNewCode(cSQL,cField: string): word;
begin
 qTmp.Active:=false;
 qTmp.SQL.Text := cSQL;
 qTmp.Active:=true;
 qTmp.First;

 If qTmp.Eof then
    Result := 1
 else
    begin
      qTmp.Last;
      Result := qTmp.FieldValues[cField] + 1;
    end;

 qTmp.Active:=false;
end;

procedure TDM.SqlInsert(cSQL,cValue1,cValue2: string);
begin
 qTmp.Active:=false;
 qTmp.SQL.Text := cSQL + ' (' + cValue1 + ',' + cValue2 + ')';
 qTmp.ExecSQL;
 qTmp.Active:=false;
end;

procedure TDM.SqlDelete(cBase, cField: string; var qTable: TQuery);
var nCode: word;
begin
  If YesToKill then
     begin
       nCode := qTable.FieldValues[cField];
       qTmp.Active:=false;
       qTmp.SQL.Text := 'delete from ' + cBase + ' where '
                      + cField + '=' + inttostr(nCode);
       qTmp.ExecSQL;
       qTmp.Active:=false;

       qTable.Active := false;
       qTable.Active := true;
     end;
end;

procedure TDM.SqlUpdate(cSQL, cField, cValue: string; var qTable: TQuery);
var nCode: word;
begin
       nCode := qTable.FieldValues[cField];

       qTmp.Active:=false;
       qTmp.SQL.Text := cSQL + '"' + cValue + '"' + ' where '
                      + cField + '=' + inttostr(nCode);
       qTmp.ExecSQL;
       qTmp.Active:=false;

       qTable.Active := false;
       qTable.Active := true;
       qTable.Locate(cField,nCode,[]);
end;

function YesToKill: boolean;
begin
  Result := (MessageDlg('  ?',
              mtConfirmation, [mbYes, mbNo], 0) = mrYes);
end;

Function Is_Empty(s: string): boolean;
var i,l: byte;
    tmps: string;
begin
     l := Length(s);

     If l = 0 then
        begin
           Is_Empty := true;
           exit;
        end;

     tmps := '';
     for i:=1 to l do
         if s[i] <> ' ' then tmps := tmps + s[i];
     Is_Empty := (tmps = '');
end;

end.

