unit uFilter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, uDM, uRace, uColor,
  uTitle;

type
  TfFilter = class(TForm)
    leName: TLabeledEdit;
    cbSex: TComboBox;
    leRace: TLabeledEdit;
    leColor: TLabeledEdit;
    leTitle: TLabeledEdit;
    bTitle: TButton;
    bColor: TButton;
    bRace: TButton;
    bOK: TBitBtn;
    bCancel: TBitBtn;
    Label1: TLabel;
    cbName: TCheckBox;
    cb_Sex: TCheckBox;
    cbRace: TCheckBox;
    cbColor: TCheckBox;
    cbTitle: TCheckBox;
    procedure cbNameClick(Sender: TObject);
    procedure cb_SexClick(Sender: TObject);
    procedure cbRaceClick(Sender: TObject);
    procedure cbColorClick(Sender: TObject);
    procedure cbTitleClick(Sender: TObject);
    procedure bRaceClick(Sender: TObject);
    procedure bColorClick(Sender: TObject);
    procedure bTitleClick(Sender: TObject);
    procedure bOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    nSex: byte;
    nRace: word;
    nColor: word;
    nTitle: byte;
    cSQL: string;
  end;

var
  fFilter: TfFilter;

implementation

{$R *.dfm}

procedure TfFilter.cbNameClick(Sender: TObject);
begin
  leName.Enabled := cbName.Checked;
end;

procedure TfFilter.cb_SexClick(Sender: TObject);
begin
  cbSex.Enabled := cb_Sex.Checked;
end;

procedure TfFilter.cbRaceClick(Sender: TObject);
begin
  leRace.Enabled := cbRace.Checked;
  bRace.Enabled := cbRace.Checked;
end;

procedure TfFilter.cbColorClick(Sender: TObject);
begin
  leColor.Enabled := cbColor.Checked;
  bColor.Enabled  := cbColor.Checked;
end;

procedure TfFilter.cbTitleClick(Sender: TObject);
begin
  leTitle.Enabled := cbTitle.Checked;
  bTitle.Enabled := cbTitle.Checked;
end;

procedure TfFilter.bRaceClick(Sender: TObject);
begin
  fRace.ShowModal;

  if fRace.ModalResult = mrOK then
     begin
       leRace.Text := fRace.cName;
       nRace := fRace.nCod;
     end;
end;

procedure TfFilter.bColorClick(Sender: TObject);
begin
  fColor.ShowModal;

  if fColor.ModalResult = mrOK then
     begin
       leColor.Text := fColor.cName;
       nColor := fColor.nCod;
     end;
end;

procedure TfFilter.bTitleClick(Sender: TObject);
begin
  fTitle.ShowModal;

  if fTitle.ModalResult = mrOK then
     begin
       leTitle.Text := fTitle.cName;
       nTitle := fTitle.nCod;
     end;
end;

procedure TfFilter.bOKClick(Sender: TObject);
  procedure MoreSQL(s: string);
  begin
    If cSQL <> '' then cSQL := cSQL+' and ';
    cSQL := cSQL + s;
  end;
begin
 cSQL := '';
 
 If cbName.Checked then MoreSQL('name="'+leName.Text+'"');
 If cb_Sex.Checked then MoreSQL('sex_cod='+IntToStr(cbSex.ItemIndex));
 If cbRace.Checked then MoreSQL('race_cod='+IntToStr(nRace));
 If cbColor.Checked then MoreSQL('color_cod='+IntToStr(nColor));
 If cbTitle.Checked then MoreSQL('title='+IntToStr(nTitle));

 If cSQL <> '' then cSQL := ' where '+cSQL;
end;

end.
