unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, DBGrids, StdCtrls, uDM, uAddPet,
  uFilter, uPedigree, ShellAPI, DBCtrls, ExtCtrls, uSort;

type
  TfMain = class(TForm)
    gPets: TDBGrid;
    bAdd: TButton;
    bEdit: TButton;
    bDelete: TButton;
    bFilter: TButton;
    bSort: TButton;
    bRod: TButton;
    fdPedigree: TSaveDialog;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    DBText1: TDBText;
    DBText2: TDBText;
    DBText3: TDBText;
    DBText4: TDBText;
    DBText5: TDBText;
    DBText6: TDBText;
    DBText7: TDBText;
    bInfo: TButton;
    procedure bAddClick(Sender: TObject);
    procedure bEditClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure bFilterClick(Sender: TObject);
    procedure bRodClick(Sender: TObject);
    procedure bSortClick(Sender: TObject);
    procedure bInfoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fMain: TfMain;

implementation

{$R *.dfm}

procedure TfMain.bAddClick(Sender: TObject);
var cSQL: string;
    nCod: word;
begin
 fAddPet.Init_Data;

 if fAddPet.ShowModal = mrOK then
    begin
      nCod := DM.GetNewCode('select cod from pets order by cod','cod');

      cSQL := 'insert into pets (name,cod,race_cod,color_cod,'
              +'title,father_cod,father_nam,'
              +'mother_cod,mother_nam,sex_cod,birth) values ('
              +'"'+trim(fAddPet.leName.Text)+'",'
              +inttostr(nCod)+','
              +inttostr(fAddPet.nRace)+','
              +inttostr(fAddPet.nColor)+','
              +inttostr(fAddPet.nTitle)+','
              +IntToStr(fAddPet.nPapa)+',"'
              +fAddPet.lePapa.Text+'",'
              +IntToStr(fAddPet.nMama)+',"'
              +fAddPet.leMama.Text+'",'
              +IntToStr(fAddPet.nSex)+',"'
              +DateToStr(fAddPet.dBirth.DateTime)+'")';

      DM.qPetsAdd.SQL.Text := cSQL;
      DM.qPetsAdd.ExecSQL;

      DM.qPetsMain.Active := false;
      DM.qPetsMain.Active := true;

      DM.qPetsMain.Locate('cod',nCod,[]);

      DM.qParent.Active := false;
      DM.qParent.Active := true;
    end;

 gPets.SetFocus;
end;

procedure TfMain.bEditClick(Sender: TObject);
var cSQL: string;
    nCod: word;
begin
 fAddPet.Load_Data;

 if fAddPet.ShowModal = mrOK then
    begin
      nCod := DM.qPetsMain.FieldValues['cod'];

      cSQL := 'update pets set '
              + 'name="' + trim(fAddPet.leName.Text)+'", '
              + 'race_cod=' + inttostr(fAddPet.nRace)+', '
              + 'color_cod=' + inttostr(fAddPet.nColor)+', '
              + 'title=' + inttostr(fAddPet.nTitle)+', '
              + 'sex_cod=' + inttostr(fAddPet.nSex)+', '
              + 'father_nam="' + trim(fAddPet.lePapa.Text)+'", '
              + 'father_cod=' + inttostr(fAddPet.nPapa)+', '
              + 'mother_nam="' + trim(fAddPet.leMama.Text)+'", '
              + 'mother_cod=' + inttostr(fAddPet.nMama)+', '
              + 'birth="' + DateToStr(fAddPet.dBirth.DateTime)+'" '
              + 'where cod=' + inttostr(nCod);

      DM.qPetsAdd.SQL.Text := cSQL;
      DM.qPetsAdd.ExecSQL;

      DM.qPetsMain.Active := false;
      DM.qPetsMain.Active := true;

      DM.qPetsMain.Locate('cod',nCod,[]);

      DM.qParent.Active := false;
      DM.qParent.Active := true;
    end;

 gPets.SetFocus;    
end;

procedure TfMain.FormShow(Sender: TObject);
begin
  dm.qPetsMain.Active := false;

  dm.qPetsMain.DatabaseName := RootDir;
  dm.qPetsAdd.DatabaseName := RootDir;
  dm.qPetsGetCode.DatabaseName := RootDir;
  dm.qRace.DatabaseName := RootDir;
  dm.qColor.DatabaseName := RootDir;
  dm.qTitle.DatabaseName := RootDir;
  dm.qTmp.DatabaseName := RootDir;
  dm.qParent.DatabaseName := RootDir;
  dm.qFindParent.DatabaseName := RootDir;


  dm.qPetsMain.SQL.Text := MainSQL.Text + SortingSQL[SortIndex];
  dm.qPetsMain.Active := true;

  dm.qParent.Active := true;
end;

procedure TfMain.bDeleteClick(Sender: TObject);
var nCod: word;
    cSQL: string;
begin
 if YesToKill then
      begin
        nCod := DM.qPetsMain.FieldValues['cod'];

        cSQL := 'delete from pets where cod='
                 + inttostr(nCod);

        DM.qPetsAdd.SQL.Text := cSQL;
        DM.qPetsAdd.ExecSQL;

        DM.qPetsMain.Active := false;
        DM.qPetsMain.Active := true;

        DM.qParent.Active := false;
        DM.qParent.Active := true;
      end;

 gPets.SetFocus;
end;

procedure TfMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dm.qPetsMain.Active := false;
  dm.qParent.Active := false;
end;

procedure TfMain.FormCreate(Sender: TObject);
begin
  MainSQL := TStringList.Create;
  MainSQL.Clear;

  MainSQL.Add('select cod, name, birth, title_name, race_name, color_name, ');
  MainSQL.Add('father_nam, mother_nam, ');
  MainSQL.Add('father_cod, mother_cod, ');
  MainSQL.Add('sex_cod, title, race_cod, color_cod ');
  MainSQL.Add('from pets left outer join race ');
  MainSQL.Add('on (pets.race_cod=race.race_cod) ');
  MainSQL.Add('left outer join title ');
  MainSQL.Add('on (pets.title=title.title_cod)');
  MainSQL.Add('left outer join color ');
  MainSQL.Add('on (pets.color_cod=color.color_cod)');

  SortingSQL[1] := ' order by name, birth';
  SortingSQL[2] := ' order by birth, name';
  SortIndex := 1;
end;

procedure RebuildMainQuery;
begin
 dm.qPetsMain.Active := false;
 dm.qPetsMain.SQL.Text := MainSQL.Text
                        + SortingSQL[SortIndex]
                        + fFilter.cSQL;
 dm.qPetsMain.Active := true;
end;

procedure TfMain.bFilterClick(Sender: TObject);
begin
  if fFilter.ShowModal = mrOK then
     begin
       RebuildMainQuery;
     end;

 gPets.SetFocus;
end;

procedure TfMain.bRodClick(Sender: TObject);
begin
  If fdPedigree.Execute then
     begin
       fPedigree.nCode := dm.qPetsMain.FieldValues['cod'];
       fPedigree.cFile := fdPedigree.FileName;
       if fPedigree.ShowModal = mrOK
          then ShellExecute(0, nil, PChar(fPedigree.cFile),
                            nil, nil, SW_SHOWNORMAL);
     end;

 gPets.SetFocus;
end;

procedure TfMain.bSortClick(Sender: TObject);
begin
 If fSort.ShowModal = mrOK then
    begin
      RebuildMainQuery;
    end;

 gPets.SetFocus;
end;

procedure TfMain.bInfoClick(Sender: TObject);
begin
 if FileExists(RootDir+'help.html')
    then ShellExecute(0, nil, PChar(RootDir+'help.html'),
                            nil, nil, SW_SHOWNORMAL)
    else ShowMessage('    '+RootDir+'help.html!');                        
end;

end.
