unit uPedigree;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, uDM;

type TPedigreeLine = record
                       s: Array[1..16] of string[32];
                       i: Array[1..16] of word;
                       n: byte;
                     end;

type
  TfPedigree = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    bViewIt: TBitBtn;
    bClose: TBitBtn;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Pedigree: Array[1..5] of TPedigreeLine;
    nCode: word;
    nDeep: byte;
    cName,cRace,cColor,cTitle,cBirth: string[32];
    cFile: string;
    procedure BuildPedigree;
  end;

var
  fPedigree: TfPedigree;

implementation

{$R *.dfm}

procedure TfPedigree.FormShow(Sender: TObject);
var i,j,k: byte;
    cTmp: string;
begin
  Pedigree[1].n := 1;

  for i:=1 to 5 do
    begin
      if i > 1 then Pedigree[i].n := Pedigree[i-1].n * 2;

      for j:=1 to 16 do
          begin
            Pedigree[i].s[j]:='';
            Pedigree[i].i[j]:=0;
          end;
    end;

  nDeep := 0;

  BuildPedigree;

  Memo1.Lines.Clear;

  Memo1.Lines.Add('<html><body><center><h1></h1>');
  Memo1.Lines.Add('<table align=center bgcolor=#ffffdd border=1>');
  Memo1.Lines.Add('<tr><td>&nbsp;: ' + cName + '&nbsp;</td></tr>');
  Memo1.Lines.Add('<tr><td>&nbsp;: ' + cRace + '&nbsp;</td></tr>');
  Memo1.Lines.Add('<tr><td>&nbsp;: ' + cColor + '&nbsp;</td></tr>');
  Memo1.Lines.Add('<tr><td>&nbsp; : ' + cBirth + '&nbsp;</td></tr>');
  Memo1.Lines.Add('<tr><td>&nbsp;: ' + cTitle + '&nbsp;</td></tr>');
  Memo1.Lines.Add('</table>');
  Memo1.Lines.Add('<table border=1 bgcolor=#ffeeff>');

  k:=16;

  for i:=1 to 5 do
      begin
        cTmp := '<tr>';

        for j:=1 to Pedigree[i].n do
            if i < 5 then
               begin
                 cTmp := cTmp + '<td align=center colspan=' + IntToStr(k) + '>' + Trim(Pedigree[i].s[j]) + '</td>';
               end
            else
               cTmp := cTmp + '<td align=center width=50px>' + Trim(Pedigree[i].s[j]) + '</td>';

        cTmp := cTmp + '</tr>';

        Memo1.Lines.Add(cTmp);

        k := k div 2;
      end;

  Memo1.Lines.Add('</table></body></html>');

  Memo1.Lines.SaveToFile(cFile);
end;

procedure TfPedigree.BuildPedigree;
var i,j,vCode: byte;
    lMale: boolean;
begin
  dm.qTmp.Active := false;
  dm.qTmp.SQL.Text := 'select name, birth, title_name, race_name, color_name, '
                     +'sex_cod from pets left outer join race '
                     +'on (pets.race_cod=race.race_cod) '
                     +'left outer join title '
                     +'on (pets.title=title.title_cod) '
                     +'left outer join color '
                     +'on (pets.color_cod=color.color_cod) '
                     +'where pets.cod=' + IntToStr(nCode);
  dm.qTmp.Active := true;

  If not dm.qTmp.Eof then
     begin
       cName := dm.qTmp.FieldValues['name'];
       cRace :=  dm.qTmp.FieldValues['race_name'];
       cColor := dm.qTmp.FieldValues['color_name'];
       cTitle := dm.qTmp.FieldValues['title_name'];
       cBirth := DateToStr(dm.qTmp.FieldValues['birth']);
     end;

  Pedigree[1].n := 1;
  Pedigree[1].i[1] := nCode;

  for i:=2 to 5 do
      begin
        lMale := false;

        for j:=1 to 16 do
            begin
              lMale := not lMale;

              if lMale then
                 begin
                   vCode := Pedigree[i-1].i[(j+1) div 2];

                   If vCode <> 0 then
                      begin
                         dm.qTmp.Active := false;
                         dm.qTmp.SQL.Text := 'select father_cod from pets where cod='+IntToStr(vCode);
                         dm.qTmp.Active := true;

                         If not dm.qTmp.Eof then
                            begin
                              Pedigree[i].i[j] := dm.qTmp.FieldValues['father_cod'];
                            end;
                      end;
                 end
              else
                 begin
                   vCode := Pedigree[i-1].i[(j div 2)];

                   If vCode <> 0 then
                      begin
                         dm.qTmp.Active := false;
                         dm.qTmp.SQL.Text := 'select mother_cod from pets where cod='+IntToStr(vCode);
                         dm.qTmp.Active := true;

                         If not dm.qTmp.Eof then
                            begin
                              Pedigree[i].i[j] := dm.qTmp.FieldValues['mother_cod'];
                            end;
                      end;
                 end;
            end;
      end;

  for i:=1 to 5 do
      for j:=1 to 16 do
          if Pedigree[i].i[j] <> 0 then
             begin
                  dm.qTmp.Active := false;
                  dm.qTmp.SQL.Text := 'select name from pets where cod='+IntToStr(Pedigree[i].i[j]);
                  dm.qTmp.Active := true;

                  If not dm.qTmp.Eof then
                     begin
                       Pedigree[i].s[j] := dm.qTmp.FieldValues['name'];
                       //Pedigree[i].n := Pedigree[i].n + 1;
                     end
                  else Pedigree[i].s[j] := '&nbsp;';
             end
           else Pedigree[i].s[j] := '&nbsp;';
end;

end.
